//
//  ListLeftVariableIconWithRightCaretBodyTextModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 21/05/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//


public class ListLeftVariableIconWithRightCaretBodyTextModel: ListItemModel, ParentMoleculeModelProtocol {
    //-----------------------------------------------------
    // MARK: - Properties
    //-----------------------------------------------------
    
    public static var identifier: String = "listLVImgBdy"
    public var image: ImageViewModel
    public var headlineBody: HeadlineBodyModel
    public var rightLabel: LabelModel
    
    public var children: [MoleculeModelProtocol] {
        [image, headlineBody, rightLabel]
    }
    
    //-----------------------------------------------------
    // MARK: - Methods
    //-----------------------------------------------------
    
    override public func setDefaults() {
        super.setDefaults()
        if image.width == nil, image.height == nil {
            image.width = 30
            image.height = 30
        }
        headlineBody.style = .item
        headlineBody.headline?.hero = 0
        if rightLabel.numberOfLines == nil {
            rightLabel.numberOfLines = 1
        }
    }
    
    //-----------------------------------------------------
    // MARK: - Initializers
    //-----------------------------------------------------
    
    public init(image: ImageViewModel, headlineBody: HeadlineBodyModel, rightLabel: LabelModel) {
        self.image = image
        self.headlineBody = headlineBody
        self.rightLabel = rightLabel
        super.init()
    }
    
    //-----------------------------------------------------
    // MARK: - Keys
    //-----------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case image
        case headlineBody
        case rightLabel
    }
    
    //-----------------------------------------------------
    // MARK: - Codec
    //-----------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        image = try typeContainer.decode(ImageViewModel.self, forKey: .image)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        rightLabel = try typeContainer.decode(LabelModel.self, forKey: .rightLabel)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(image, forKey: .image)
        try container.encode(headlineBody, forKey: .headlineBody)
        try container.encode(rightLabel, forKey: .rightLabel)
    }
}
